REM INFO: PapersizeX.csc v1.1.1 (PP9)
REM No copyright!  Created by James Aswell
REM -> Corrected error handler issue
REM -> Added additional error message for no open document.
REM 
REM DESCRIPTION:
REM		This script was created to provide users with the functionality of
REM 		.v 8's Paper Size Dialog. If you have any comments or suggestions,
REM 		please direct them to: notreal@concentric.net
REM 		If you have any useful modifications, please make them public so
REM 		they can be of use to others!
REM
REM Things that need to be implemented:
REM 		support for color models other than RGB
REM 		that nifty preview graphic ( is this even possible?? )

ON ERROR GOTO ErrorHandler

GLOBAL DDComboBox1Arr(10)
	DDComboBox1Arr(1) = "Top Left"
	DDComboBox1Arr(2) = "Top Center"	
	DDComboBox1Arr(3) = "Top Right"
	DDComboBox1Arr(4) = "Center Left"
	DDComboBox1Arr(5) = "Centered"
	DDComboBox1Arr(6) = "Center Right"
	DDComboBox1Arr(7) = "Bottom Left"
	DDComboBox1Arr(8) = "Bottom Center"
	DDComboBox1Arr(9) = "Bottom Right"
	DDComboBox1Arr(10) = "Custom"	

Global	OldWidth 		as double
Global 	OldHeight		as double
Global 	NewWidth	 	as integer
Global 	NewHeight		as integer
Global	Check		as integer
Global	CR			as long
Global	CG			as long
Global	CB			as long
Global	CO			as long
Global	CM			as long

WITHOBJECT "CorelPhotoPaint.Automation.9"


	OldWidth = .GetDocumentWidth()
	OldHeight = .GetDocumentHeight()
	NewWidth = OldWidth
	NewHeight = OldHeight

	CM = 5
	CR = 255
	CG = 255
	CB = 255
	CO = 0

	.GetPaperColor CM, CR, CG, CB, CO

	check% = 0

	BEGIN DIALOG About 177, 115, "About .v8 Style Paper Size Dialog"
		TEXT  5, 4, 165, 27, "This script was created to provide users with the functionality of .v 8's Paper Size Dialog.  If you have any comments or suggestions, please direct them to:"
		TEXT  35, 38, 102, 8, "notreal@concentric.net"
		TEXT  5, 57, 165, 20, "If you have any useful modifications, please make them public so they can be of use to others!"
		OKBUTTON  49, 93, 75, 16
	END DIALOG

	BEGIN DIALOG OBJECT Paper 176, 140, ".v8 Style Paper Size Dialog", SUB PAPERS
		TEXT  40, 66, 24, 8, .OldWidth, OldWidth
		TEXT  41, 81, 24, 8, .OldHeight, OldHeight
		TEXT  10, 66, 25, 8, .Width, "Width:"
		TEXT  10, 82, 25, 8, .Height, "Height:"
		DDCOMBOBOX  53, 13, 80, 66, .DDComboBox1Arr
		SPINCONTROL  72, 62, 36, 15, .NewWidth	 ' Control ID 6
		SPINCONTROL  72, 79, 36, 15, .NewHeight	 ' Control ID 7
		OKBUTTON  12, 121, 50, 15, .OK
		CANCELBUTTON  66, 121, 50, 15, .Cancel
		GROUPBOX  3, 49, 169, 65, .ImageSize, "Image Size"
		TEXT  5, 14, 36, 8, .Placement, "P&lacement:"
		PUSHBUTTON  120, 121, 50, 15, .About, "About"
		PUSHBUTTON  53, 30, 30, 14, .Color, "Color"
		TEXT  5, 32, 40, 8, .PaperColor, "&Paper color:"
		CHECKBOX  7, 98, 80, 10, .Aspect, "&Maintain aspect ratio"
	END DIALOG

	ret = DIALOG(Paper)

	IF ret = 2 THEN STOP

	DDComboBox1Txt = Paper.DDComboBox1Arr.GETSELECT() 

	IF DDComboBox1Txt = DDComboBox1Arr(1) THEN		'Top Left
		XOff% = 0
		YOff% = -(NewHeight - OldHeight)

	ELSEIF DDComboBox1Txt = DDComboBox1Arr(2) THEN	'Top Center
		XOff% = ((NewWidth - OldWidth) / 2)
		YOff% = -(NewHeight - OldHeight)
	
	ELSEIF DDComboBox1Txt = DDComboBox1Arr(3) THEN	'Top Right
		XOff% = (NewWidth - OldWidth)
		YOff% = -(NewHeight - OldHeight)
	
	ELSEIF DDComboBox1Txt = DDComboBox1Arr(4) THEN	'Center Left
		XOff% = 0
		YOff% = -((NewHeight - OldHeight) / 2)
		
	ELSEIF DDComboBox1Txt = DDComboBox1Arr(5) THEN	'Centered
		XOff% = ((NewWidth - OldWidth) / 2)
		YOff% = -((NewHeight - OldHeight) / 2)
		
	ELSEIF DDComboBox1Txt = DDComboBox1Arr(6) THEN	'Center Right
		XOff% = (NewWidth - OldWidth)
		YOff% = -((NewHeight - OldHeight) / 2)
	
	ELSEIF DDComboBox1Txt = DDComboBox1Arr(7) THEN	'Bottm Left
		XOff% = 0
		YOff% = 0
		
	ELSEIF DDComboBox1Txt = DDComboBox1Arr(8) THEN	'Bottom Center
		XOff% = ((NewWidth - OldWidth) / 2)
		YOff% = 0
		
	ELSEIF DDComboBox1Txt = DDComboBox1Arr(9) THEN	'Bottom Right
		XOff% = (NewWidth - OldWidth)
		YOff% = 0
	
	ELSEIF DDComboBox1Txt = DDComboBox1Arr(10) THEN	'Custom
		check% = 1
	ENDIF
	
	IF check% = 0 THEN .ImagePapersize NewWidth, NewHeight, XOff%, YOff%, 5, CR, CG, CB, CO
	IF check% = 1 THEN .ImagePapersize

	STOP

	SUB PAPERS(BYVAL ControlID%, BYVAL Event%)
	
		CWidth% = Paper.NewWidth.GETVALUE()
	 	CHeight% = Paper.NewHeight.GETVALUE()

		IF Paper.Aspect.GETVALUE() = 1 THEN
			IF ControlID% = 6 THEN Paper.NewHeight.SETVALUE ( ( (CWidth%/OldWidth) * OldHeight) + 0.45 )
			IF ControlID% = 7 THEN Paper.NewWidth.SETVALUE ( ( (CHeight%/OldHeight) * OldWidth) + 0.45 )
		ENDIF

		IF Event = 0 THEN
			Paper.OldWidth.SETTEXT OldWidth
			Paper.OldHeight.SETTEXT OldHeight
	
			Paper.DDComboBox1Arr.SETARRAY DDComboBox1Arr	
			Paper.DDComboBox1Arr.SETSELECT DDComboBox1Arr(5)
		
			Paper.NewWidth.SETVALUE OldWidth
			Paper.NewWidth.SETMINRANGE 1
		
			Paper.NewHeight.SETVALUE OldHeight
			Paper.NewHeight.SETMINRANGE 1
			
			Paper.Aspect.SETTHREESTATE FALSE
			Paper.Aspect.ENABLE TRUE
			Paper.Aspect.SETVALUE 1
		
		 	NewWidth = Paper.NewWidth.GETVALUE()
		 	NewHeight = Paper.NewHeight.GETVALUE()
		
		ELSE
		 	NewWidth = Paper.NewWidth.GETVALUE()
		 	NewHeight = Paper.NewHeight.GETVALUE()
		
		ENDIF
	
		IF ControlID% = 12 AND Event% = 2 THEN ret = DIALOG(About)
		IF ControlID% = 13 AND Event% = 2 THEN 
			GETCOLOR CR, CG, CB
		ENDIF
	
	End SUB
	
END WITHOBJECT
	
ErrorHandler:
	SELECT CASE ERRNUM
	CASE 1004
		REM User canceled the custom dialog.
	CASE 1002
		MESSAGE "This script requires an open document."
	CASE ELSE
		MESSAGE "Unexpected error: " + CSTR(ERRNUM)
		RESUME NEXT
	END SELECT
STOP



